using Encompass;
using PongFE.Components;
using PongFE.Messages;

namespace PongFE.Engines
{
    [Receives(typeof(UpdatePositionMessage))]
    [Writes(typeof(PositionComponent))]
    public class UpdatePositionEngine : Engine
    {
        public override void Update(double dt)
        {
            foreach (ref readonly var message in ReadMessages<UpdatePositionMessage>())
            {
                SetComponent(message.Entity, new PositionComponent(message.Position));
            }
        }
    }
}
